#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "stairs2"

const int MaxN = 21;

int a [MaxN];
int l, h;

int recur (int n, int k)
{
 if (a[n] > k) return 0;
 if (n == l) return (k == h);
 return recur (n + 1, k + 1) + recur (n + 1, k + 2);
}

int main (void)
{
 int i;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &l, &h) != EOF)
 {
  for (i = 0; i <= l; i++)
   scanf (" %d", &a[i]);
  printf ("%d\n", recur (0, 0));
 }
 return 0;
}
