#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "stairs2"

const int MaxN = 20;

int f [MaxN] [MaxN];
int a [MaxN];
int l, h;

int main (void)
{
 int i, j;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &l, &h) != EOF)
 {
  for (i = 0; i <= l; i++)
   scanf (" %d", &a[i]);
  memset (f, 0, sizeof (f));
  f[0][0] = 1;
  for (i = 0; i < l; i++)
   for (j = 0; j < h; j++)
   {
    if (a[i + 1] <= j + 1) f[i + 1][j + 1] += f[i][j];
    if (a[i + 1] <= j + 2) f[i + 1][j + 2] += f[i][j];
   }
  printf ("%d\n", f[l][h]);
 }
 return 0;
}
