#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "circle"

const int MaxN = 100, MaxK = 10;

int num [MaxN * 2];
int a [MaxK];
int b [MaxK];
int n, k;

int main (void)
{
 int i, res;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &k) != EOF)
 {
  for (i = 0; i < k; i++)
   scanf (" %d", &a[i]), a[i]--;
  for (i = 0; i < k; i++)
   scanf (" %d", &b[i]), b[i]--;
  memset (num, -1, sizeof (num));
  for (i = 0; i < k; i++)
   if (b[i] < a[i])
    b[i] += n;
  for (i = 0; i < k; i++)
   num[a[i]] = i;
  for (res = 0; res < MaxN; res++)
  {
   for (i = 0; i < k; i++)
    if (a[i] != b[i] && num[a[i] + 1] == -1)
     break;
   if (i == k) break;
   num[a[i]] = -1;
   a[i]++;
   num[a[i]] = i;
  }
  printf ("%d\n", res);
 }
 return 0;
}
