#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>

#define TASKNAME "permut"

const int MaxN = 10000;

int ans [MaxN], p [MaxN], q [MaxN], b [MaxN];
int n, k;

void outp (int * p)
{
 int i;
 for (i = 0; i < n; i++)
  printf ("%d%c", p[i] + 1, i + 1 < n ? ' ' : '\n');
}

void mult (int * p, int * q)
{
 int r [MaxN];
 int i;
 for (i = 0; i < n; i++)
  r[i] = q[p[i]];
 memmove (p, r, n * sizeof (int));
}

int main (void)
{
 int i, j, l, m;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &k) != EOF)
 {
  for (i = 0; i < n; i++)
  {
   scanf (" %d", &p[i]);
   p[i]--;
  }
  memset (b, 0, sizeof (b));
  for (i = 0; i < n; i++)
   if (!b[i])
   {
    j = i;
    m = 0;
    do
    {
     b[j] = 1;
     q[m++] = j;
     j = p[j];
    }
    while (j != i);
    l = 0;
    do
    {
     b[j] = 2;
     ans[j] = q[(l + k) % m];
     j = p[j];
     l++;
    }
    while (j != i);
   }
  outp (ans);
 }
 return 0;
}
