#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "stairs2"

const int MaxN = 21;

int a [MaxN];
int l, h;
int count;

int recur (int n, int k)
{
 count++;
 if (count > 0x3F3F3F3F) return 0;
 if (n > l) return -1;
 if (a[n] > k) return 0;
 if (n == l) return (k == h);
 int res;
 res = 0;
 if (recur (n + 1, k + 1) != -1)
  res += recur (n + 1, k + 1);
 if (recur (n + 1, k + 2) != -1)
  res += recur (n + 1, k + 2);
 return res;
}

int main (void)
{
 int i;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &l, &h) != EOF)
 {
  for (i = 0; i <= l; i++)
   scanf (" %d", &a[i]);
  count = 0;
  printf ("%d\n", recur (0, 0));
 }
 return 0;
}
